diff -rupN newpd/pd-0.45-0/tcl/dialog_midi.tcl pd-0.45-0/tcl/dialog_midi.tcl
--- newpd/pd-0.45-0/tcl/dialog_midi.tcl	2013-08-07 16:29:37.000000000 -0400
+++ pd-0.45-0/tcl/dialog_midi.tcl	2013-08-27 12:37:35.806358982 -0400
@@ -38,27 +38,80 @@ proc ::dialog_midi::ok {mytoplevel} {
     ::dialog_midi::cancel $mytoplevel
 }
 
-# callback from popup menu
-proc midi_popup_action {buttonname varname devlist index} {
-    global midi_indevlist midi_outdevlist $varname
-    $buttonname configure -text [lindex $devlist $index]
-    set $varname $index
+proc ::dialog_midi::setapi {var - op} {
+    if {$op ne "write"} {return}
+    set name [set $var]
+    set index [lsearch -exact -index 0 $::midi_apilist $name]
+    set ::pd_whichmidiapi [lindex $::midi_apilist $index 1]
+    pdsend "pd midi-setapi $::pd_whichmidiapi"
 }
 
-# create a popup menu
-proc midi_popup {name buttonname varname devlist} {
-    if [winfo exists $name.popup] {destroy $name.popup}
-    menu $name.popup -tearoff false
-    if {$::windowingsystem eq "win32"} {
-        $name.popup configure -font menuFont
+proc ::dialog_midi::setlongform {widget} {
+    set state [set ::$widget]
+    if {$state == 0} {
+        # back to single devs
+        set extra_devs 0
+        foreach type {in out} {
+            foreach i {2 3 4} {
+                if { [set ::midi_${type}chan$i] > 0 &&
+                     [set ::midi_${type}enable$i] > 0 } {
+                          incr extra_devs
+                }
+            }
+        }
+        if {$extra_devs} {
+            set devices devices
+            if {$extra_devs == 1} {set devices device}
+            set continue [tk_messageBox -type yesno -message \
+                [_ "This will disconnect $extra_devs $devices. Continue?"] \
+                 -default "no" -parent [winfo parent $widget] -icon question]
+            if {$continue eq "yes"} {
+               foreach type {in out} {
+                   foreach i {2 3 4} {
+                       set ::midi_${type}chan$i 0
+                       set ::midi_${type}enable$i 0
+                   }
+               }
+            ::dialog_midi::apply [winfo parent $widget]
+            }
+        }
     }
-#    puts stderr [concat $devlist ]
-    for {set x 0} {$x<[llength $devlist]} {incr x} {
-        $name.popup add command -label [lindex $devlist $x] \
-            -command [list midi_popup_action \
-                $buttonname $varname $devlist $x] 
+    pdsend "pd midi-properties $state"
+}
+
+proc ::dialog_midi::create_api_frame {mytoplevel apifr midi_indevlist \
+    midi_outdevlist longform} {
+    if {![winfo exists $apifr]} {
+
+        # MIDI API
+        ttk::labelframe $mytoplevel.api -text [_ "Midi API"] \
+            -style Prefs.TLabelframe
+        pack $apifr -side top -padx 1 -pady 1 -fill x
+        if {$::midi_apilist eq ""} {
+            ttk::label $apifr.label -text "System Midi"
+            grid $apifr.label -sticky e -column 0 -row 0 -padx 3 -pady 10
+        } else {
+            set api_names {}
+            foreach api $::midi_apilist {lappend api_names [lindex $api 0]}
+            set api_i [lsearch -exact -index 1 $::midi_apilist \
+                $::pd_whichmidiapi]
+            set ::midi_apiname [lindex $::midi_apilist $api_i 0]
+            ::dialog_prefs::dropdown $apifr.apilist ::midi_apiname $api_names
+            trace add variable ::midi_apiname write ::dialog_midi::setapi
+            grid $apifr.apilist -sticky e -column 0 -row 0 -padx 3 -pady 10
+        }
+        ttk::checkbutton $apifr.longbutton -text "Use multiple devices" \
+            -command "::dialog_midi::setlongform $apifr.longbutton"
+        grid $apifr.longbutton -sticky w -column 1 -row 0 -padx 3 -pady 10
+        grid columnconfigure $apifr {0 1} -weight 1
+    }
+    # disable longbutton if hardware doesn't support multi devices
+    set state normal
+    if {![expr [llength $midi_indevlist] > 1 && \
+        [llength $midi_outdevlist] > 1]} {
+            set state disabled
     }
-    tk_popup $name.popup [winfo pointerx $name] [winfo pointery $name] 0
+    $apifr.longbutton configure -state disabled
 }
 
 # start a dialog window to select midi devices.  "longform" asks us to make
@@ -66,11 +119,11 @@ proc midi_popup {name buttonname varname
 # turn longform on and restart the dialog.
 proc ::dialog_midi::pdtk_midi_dialog {id indev1 indev2 indev3 indev4 \
         outdev1 outdev2 outdev3 outdev4 longform} {
-    global midi_indev1 midi_indev2 midi_indev3 midi_indev4 
+    global midi_indev1 midi_indev2 midi_indev3 midi_indev4
     global midi_outdev1 midi_outdev2 midi_outdev3 midi_outdev4
     global midi_indevlist midi_outdevlist
     global midi_alsain midi_alsaout
-
+    global midi_longform
     set midi_indev1 $indev1
     set midi_indev2 $indev2
     set midi_indev3 $indev3
@@ -81,128 +134,90 @@ proc ::dialog_midi::pdtk_midi_dialog {id
     set midi_outdev4 $outdev4
     set midi_alsain [llength $midi_indevlist]
     set midi_alsaout [llength $midi_outdevlist]
-
-    toplevel $id -class DialogWindow
-    wm title $id [_ "MIDI Settings"]
-    wm group $id .
-    wm resizable $id 0 0
-    wm transient $id
-    $id configure -menu $::dialog_menubar
-    $id configure -padx 10 -pady 5
-    ::pd_bindings::dialog_bindings $id "midi"
-    # not all Tcl/Tk versions or platforms support -topmost, so catch the error
-    catch {wm attributes $id -topmost 1}
-
-    frame $id.buttonframe
-    pack $id.buttonframe -side bottom -fill x -pady 2m
-    button $id.buttonframe.cancel -text [_ "Cancel"]\
-        -command "::dialog_midi::cancel $id"
-    button $id.buttonframe.apply -text [_ "Apply"]\
-        -command "::dialog_midi::apply $id"
-    button $id.buttonframe.ok -text [_ "OK"]\
-        -command "::dialog_midi::ok $id"
-    pack $id.buttonframe.cancel -side left -expand 1
-    pack $id.buttonframe.apply -side left -expand 1
-    pack $id.buttonframe.ok -side left -expand 1
-    
-        # input device 1
-    frame $id.in1f
-    pack $id.in1f -side top
-
-    label $id.in1f.l1 -text [_ "Input device 1:"]
-    button $id.in1f.x1 -text [lindex $midi_indevlist $midi_indev1] \
-        -command [list midi_popup $id $id.in1f.x1 midi_indev1 $midi_indevlist]
-    pack $id.in1f.l1 $id.in1f.x1 -side left
-
-        # input device 2
-    if {$longform && [llength $midi_indevlist] > 2} {
-        frame $id.in2f
-        pack $id.in2f -side top
-
-        label $id.in2f.l1 -text [_ "Input device 2:"]
-        button $id.in2f.x1 -text [lindex $midi_indevlist $midi_indev2] \
-            -command [list midi_popup $id $id.in2f.x1 midi_indev2 \
-                $midi_indevlist]
-        pack $id.in2f.l1 $id.in2f.x1 -side left
-    }
-
-        # input device 3
-    if {$longform && [llength $midi_indevlist] > 3} {
-        frame $id.in3f
-        pack $id.in3f -side top
-
-        label $id.in3f.l1 -text [_ "Input device 3:"]
-        button $id.in3f.x1 -text [lindex $midi_indevlist $midi_indev3] \
-            -command [list midi_popup $id $id.in3f.x1 midi_indev3 \
-                $midi_indevlist]
-        pack $id.in3f.l1 $id.in3f.x1 -side left
-    }
-
-        # input device 4
-    if {$longform && [llength $midi_indevlist] > 4} {
-        frame $id.in4f
-        pack $id.in4f -side top
-
-        label $id.in4f.l1 -text [_ "Input device 4:"]
-        button $id.in4f.x1 -text [lindex $midi_indevlist $midi_indev4] \
-            -command [list midi_popup $id $id.in4f.x1 midi_indev4 \
-                $midi_indevlist]
-        pack $id.in4f.l1 $id.in4f.x1 -side left
-    }
-
-        # output device 1
-
-    frame $id.out1f
-    pack $id.out1f -side top
-    label $id.out1f.l1 -text [_ "Output device 1:"]
-    button $id.out1f.x1 -text [lindex $midi_outdevlist $midi_outdev1] \
-        -command [list midi_popup $id $id.out1f.x1 midi_outdev1 \
-            $midi_outdevlist]
-    pack $id.out1f.l1 $id.out1f.x1 -side left
-
-        # output device 2
-    if {$longform && [llength $midi_outdevlist] > 2} {
-        frame $id.out2f
-        pack $id.out2f -side top
-        label $id.out2f.l1 -text [_ "Output device 2:"]
-        button $id.out2f.x1 -text [lindex $midi_outdevlist $midi_outdev2] \
-            -command \
-            [list midi_popup $id $id.out2f.x1 midi_outdev2 $midi_outdevlist]
-        pack $id.out2f.l1 $id.out2f.x1 -side left
-    }
-
-        # output device 3
-    if {$longform && [llength $midi_outdevlist] > 3} {
-        frame $id.out3f
-        pack $id.out3f -side top
-        label $id.out3f.l1 -text [_ "Output device 3:"]
-        button $id.out3f.x1 -text [lindex $midi_outdevlist $midi_outdev3] \
-            -command \
-            [list midi_popup $id $id.out3f.x1 midi_outdev3 $midi_outdevlist]
-        pack $id.out3f.l1 $id.out3f.x1 -side left
-    }
-
-        # output device 4
-    if {$longform && [llength $midi_outdevlist] > 4} {
-        frame $id.out4f
-        pack $id.out4f -side top
-        label $id.out4f.l1 -text [_ "Output device 4:"]
-        button $id.out4f.x1 -text [lindex $midi_outdevlist $midi_outdev4] \
-            -command \
-            [list midi_popup $id $id.out4f.x1 midi_outdev4 $midi_outdevlist]
-        pack $id.out4f.l1 $id.out4f.x1 -side left
-    }
-
-        # if not the "long form" make a button to
-        # restart with longform set. 
-    
-    if {$longform == 0} {
-        frame $id.longbutton
-        pack $id.longbutton -side top
-        button $id.longbutton.b -text [_ "Use multiple devices"] \
-            -command  {pdsend "pd midi-properties 1"}
-        pack $id.longbutton.b
-    }
+    set midi_longform $longform
+    set mytoplevel .prefs.nb.midi
+    set apifr $mytoplevel.api
+
+    # not sure why it's ...midi.midi... should probably
+    # fix that...
+    ::dialog_midi::create_api_frame $mytoplevel $apifr $midi_indevlist \
+        $midi_outdevlist $longform
+    destroy $mytoplevel.midi
+    ttk::frame $mytoplevel.midi
+    pack $mytoplevel.midi -side top -fill x
+
+    # todo: put padding with style settings in dialog_prefs.tcl
+    set padx 1
+
+    # Devices 
+    set devfr [ttk::labelframe $mytoplevel.midi.devs -text [_ "Devices"] \
+        -style Prefs.TLabelframe -padding 5]
+    pack $devfr -side top -fill x -padx 3 -pady 10
+
+    set j 2
+    # todo: change in out to input output and make translatable strings
+    foreach {type name} [list in [_ "Input"] out [_ "Output"]] {
+        set domulti [expr $longform && \
+            [llength [set "midi_${type}devlist"]] > 1]
+        if {$domulti} {
+            ttk::label $devfr.$type \
+                -text [concat $name [_ "Devices"]]
+            ttk::label $devfr.${type}ch -text [_ "Channels"]
+            grid $devfr.$type -row $j -column 1 -padx $padx
+            grid $devfr.${type}ch -row $j -column 3 -padx $padx
+            incr j
+        } else {
+            if {$type eq "in"} {
+            ttk::label $devfr.$type \
+                -text [_ "Device Name"]
+            ttk::label $devfr.${type}ch -text [_ "Channels"]
+            grid $devfr.$type -row $j -column 1 -columnspan 2 -padx $padx
+            grid $devfr.${type}ch -row $j -column 3 -padx $padx
+            incr j
+            }
+        }
+        # Note: it'd be fairly easy to change the GUI to accommodate
+        # more than four devices, but Pd only takes and receives at most
+        # four devices, so the entire backend would have to change in order
+        # to do that
+        for {set i 0} {$i < 4} {incr i} {
+            set devno [expr $i + 1]
+            set row "$devfr.${type}$devno"
+            if {$domulti} {
+                set ctext "$devno."
+            } else {
+                set ctext $name
+            }
+            ttk::label ${row}x0 -text $ctext -anchor w
+            set ::midi_${type}dev${devno}label {}
+            ::dialog_prefs::dropdown_by_index ${row}x1 \
+                "::midi_${type}dev$devno" \
+                [set "midi_${type}devlist"] \
+                "::midi_${type}dev${devno}label"
+            ttk::entry ${row}x2 -textvariable "midi_${type}chan$devno" -width 4
+            grid ${row}x0 -row $j -column 0 -sticky e -padx $padx
+            grid ${row}x1 -row $j -column 1 -columnspan 2 -sticky ew -padx $padx
+            grid ${row}x2 -row $j -column 3 -padx $padx
+            grid columnconfigure $mytoplevel.midi.devs {1 2 3} -weight 2
+            grid columnconfigure $mytoplevel.midi.devs 0 -weight 1
+            incr j
+            if {![expr $longform && \
+                [llength [set "midi_${type}devlist"]] > 1]} {
+                break
+            }
+        }
+    }
+    grid rowconfigure $devfr all -pad 3
+
+    # Connect button
+    ttk::frame $mytoplevel.midi.buttonframe
+    pack $mytoplevel.midi.buttonframe
+    pack $mytoplevel.midi.buttonframe -side bottom
+    ttk::button $mytoplevel.midi.buttonframe.apply \
+        -text [_ "Apply MIDI Settings"] \
+        -command "::dialog_midi::apply $mytoplevel"
+    pack $mytoplevel.midi.buttonframe.apply -side left -expand 1 -fill x \
+        -padx 15
 }
 
 proc ::dialog_midi::pdtk_alsa_midi_dialog {id indev1 indev2 indev3 indev4 \
@@ -211,7 +226,6 @@ proc ::dialog_midi::pdtk_alsa_midi_dialo
     global midi_outdev1 midi_outdev2 midi_outdev3 midi_outdev4
     global midi_indevlist midi_outdevlist
     global midi_alsain midi_alsaout
-
     set midi_indev1 $indev1
     set midi_indev2 $indev2
     set midi_indev3 $indev3
@@ -222,130 +236,91 @@ proc ::dialog_midi::pdtk_alsa_midi_dialo
     set midi_outdev4 $outdev4
     set midi_alsain [llength $midi_indevlist]
     set midi_alsaout [llength $midi_outdevlist]
-    
-    toplevel $id
-    wm title $id [_ "ALSA MIDI Settings"]
-    if {$::windowingsystem eq "aqua"} {$id configure -menu .menubar}
-    ::pd_bindings::dialog_bindings $id "midi"
-
-    frame $id.buttonframe
-    pack $id.buttonframe -side bottom -fill x -pady 2m
-    button $id.buttonframe.cancel -text [_ "Cancel"]\
-        -command "::dialog_midi::cancel $id"
-    button $id.buttonframe.apply -text [_ "Apply"]\
-        -command "::dialog_midi::apply $id"
-    button $id.buttonframe.ok -text [_ "OK"]\
-        -command "::dialog_midi::ok $id"
-    pack $id.buttonframe.cancel -side left -expand 1
-    pack $id.buttonframe.apply -side left -expand 1
-    pack $id.buttonframe.ok -side left -expand 1
-
-    frame $id.in1f
-    pack $id.in1f -side top
-
-  if {$alsa == 0} {
-        # input device 1
-    label $id.in1f.l1 -text [_ "Input device 1:"]
-    button $id.in1f.x1 -text [lindex $midi_indevlist $midi_indev1] \
-        -command [list midi_popup $id $id.in1f.x1 midi_indev1 $midi_indevlist]
-    pack $id.in1f.l1 $id.in1f.x1 -side left
-
-        # input device 2
-    if {$longform && [llength $midi_indevlist] > 2} {
-        frame $id.in2f
-        pack $id.in2f -side top
-
-        label $id.in2f.l1 -text [_ "Input device 2:"]
-        button $id.in2f.x1 -text [lindex $midi_indevlist $midi_indev2] \
-            -command [list midi_popup $id $id.in2f.x1 midi_indev2 \
-                $midi_indevlist]
-        pack $id.in2f.l1 $id.in2f.x1 -side left
-    }
-
-        # input device 3
-    if {$longform && [llength $midi_indevlist] > 3} {
-        frame $id.in3f
-        pack $id.in3f -side top
-
-        label $id.in3f.l1 -text [_ "Input device 3:"]
-        button $id.in3f.x1 -text [lindex $midi_indevlist $midi_indev3] \
-            -command [list midi_popup $id $id.in3f.x1 midi_indev3 \
-                $midi_indevlist]
-        pack $id.in3f.l1 $id.in3f.x1 -side left
-    }
+    set mytoplevel .prefs.nb.midi
+    set apifr $mytoplevel.api
 
-        # input device 4
-    if {$longform && [llength $midi_indevlist] > 4} {
-        frame $id.in4f
-        pack $id.in4f -side top
-
-        label $id.in4f.l1 -text [_ "Input device 4:"]
-        button $id.in4f.x1 -text [lindex $midi_indevlist $midi_indev4] \
-            -command [list midi_popup $id $id.in4f.x1 midi_indev4 \
-                $midi_indevlist]
-        pack $id.in4f.l1 $id.in4f.x1 -side left
-    }
-
-        # output device 1
-
-    frame $id.out1f
-    pack $id.out1f -side top
-    label $id.out1f.l1 -text [_ "Output device 1:"]
-    button $id.out1f.x1 -text [lindex $midi_outdevlist $midi_outdev1] \
-        -command [list midi_popup $id $id.out1f.x1 midi_outdev1 \
-            $midi_outdevlist]
-    pack $id.out1f.l1 $id.out1f.x1 -side left
-
-        # output device 2
-    if {$longform && [llength $midi_outdevlist] > 2} {
-        frame $id.out2f
-        pack $id.out2f -side top
-        label $id.out2f.l1 -text [_ "Output device 2:"]
-        button $id.out2f.x1 -text [lindex $midi_outdevlist $midi_outdev2] \
-            -command \
-            [list midi_popup $id $id.out2f.x1 midi_outdev2 $midi_outdevlist]
-        pack $id.out2f.l1 $id.out2f.x1 -side left
-    }
-
-        # output device 3
-    if {$longform && [llength $midi_outdevlist] > 3} {
-        frame $id.out3f
-        pack $id.out3f -side top
-        label $id.out3f.l1 -text [_ "Output device 3:"]
-        button $id.out3f.x1 -text [lindex $midi_outdevlist $midi_outdev3] \
-            -command \
-            [list midi_popup $id $id.out3f.x1 midi_outdev3 $midi_outdevlist]
-        pack $id.out3f.l1 $id.out3f.x1 -side left
-    }
-
-        # output device 4
-    if {$longform && [llength $midi_outdevlist] > 4} {
-        frame $id.out4f
-        pack $id.out4f -side top
-        label $id.out4f.l1 -text [_ "Output device 4:"]
-        button $id.out4f.x1 -text [lindex $midi_outdevlist $midi_outdev4] \
-            -command \
-            [list midi_popup $id $id.out4f.x1 midi_outdev4 $midi_outdevlist]
-        pack $id.out4f.l1 $id.out4f.x1 -side left
-    }
-
-        # if not the "long form" make a button to
-        # restart with longform set. 
-    
-    if {$longform == 0} {
-        frame $id.longbutton
-        pack $id.longbutton -side top
-        button $id.longbutton.b -text [_ "Use multiple ALSA devices"] \
-            -command  {pdsend "pd midi-properties 1"}
-        pack $id.longbutton.b
-    }
-    }
-    if {$alsa} {
-        label $id.in1f.l1 -text [_ "In Ports:"]
-        entry $id.in1f.x1 -textvariable midi_alsain -width 4
-        pack $id.in1f.l1 $id.in1f.x1 -side left
-        label $id.in1f.l2 -text [_ "Out Ports:"]
-        entry $id.in1f.x2 -textvariable midi_alsaout -width 4
-        pack $id.in1f.l2 $id.in1f.x2 -side left
-    }
+    # not sure why it's ...midi.midi... should probably
+    # fix that...
+    ::dialog_midi::create_api_frame $mytoplevel $apifr $midi_indevlist \
+        $midi_outdevlist $longform
+    destroy $mytoplevel.midi
+    ttk::frame $mytoplevel.midi
+    pack $mytoplevel.midi -side top -fill x
+
+    # todo: put padding with style settings in dialog_prefs.tcl
+    set padx 1
+
+    # Devices 
+    set devfr [ttk::labelframe $mytoplevel.midi.devs -text [_ "Devices"] \
+        -style Prefs.TLabelframe -padding 5]
+    pack $devfr -side top -fill x -padx 3 -pady 10
+
+    if {$alsa == 0} {
+        set j 2
+        foreach {type name} [list in [_ "Input"] out [_ "Output"]] {
+            set domulti [expr $longform && \
+                [llength [set "midi_${type}devlist"]] > 1]
+            if {$domulti} {
+                ttk::label $devfr.$type \
+                    -text [concat $name [_ "Devices"]]
+                ttk::label $devfr.${type}ch -text [_ "Channels"]
+                grid $devfr.$type -row $j -column 1 -padx $padx
+                grid $devfr.${type}ch -row $j -column 3 -padx $padx
+                incr j
+            } else {
+                if {$type eq "in"} {
+                ttk::label $devfr.$type \
+                    -text [_ "Device Name"]
+                ttk::label $devfr.${type}ch -text [_ "Channels"]
+                grid $devfr.$type -row $j -column 1 -columnspan 2 -padx $padx
+                grid $devfr.${type}ch -row $j -column 3 -padx $padx
+                incr j
+                }
+            }
+            for {set i 0} {$i < [llength [set "midi_${type}devlist"]]} \
+                {incr i} {
+                set devno [expr $i + 1]
+                set row "$devfr.${type}$devno"
+                if {$domulti} {
+                    set ctext "$devno."
+                } else {
+                    set ctext $name
+                }
+                ttk::label ${row}x0 -text $ctext -anchor w
+                set ::midi_${type}dev${devno}label {}
+                ::dialog_prefs::dropdown_by_index ${row}x1 \
+                    "midi_${type}dev$devno" \
+                    [set "midi_${type}devlist"] \
+                    "::midi_${type}dev${devno}label"
+                ttk::entry ${row}x2 -textvariable "midi_${type}chan$devno" -width 4
+                grid ${row}x0 -row $j -column 0 -sticky e -padx $padx
+                grid ${row}x1 -row $j -column 1 -columnspan 2 -sticky ew -padx $padx
+                grid ${row}x2 -row $j -column 3 -padx $padx
+                grid columnconfigure $mytoplevel.midi.devs {1 2 3} -weight 2
+                grid columnconfigure $mytoplevel.midi.devs 0 -weight 1
+                incr j
+                if {![expr $longform && \
+                    [llength [set "midi_${type}devlist"]] > 1]} {
+                    break
+                }
+            }
+        }
+        grid rowconfigure $devfr all -pad 3
+    } else {
+        label $devfr.l1 -text [_ "In Ports:"]
+        entry $devfr.x1 -textvariable midi_alsain -width 4
+        pack $devfr.l1 $devfr.x1 -side left
+        label $devfr.l2 -text [_ "Out Ports:"]
+        entry $devfr.x2 -textvariable midi_alsaout -width 4
+        pack $devfr.l2 $devfr.x2 -side left
+    }
+
+    # Connect button
+    ttk::frame $mytoplevel.midi.buttonframe
+    pack $mytoplevel.midi.buttonframe
+    pack $mytoplevel.midi.buttonframe -side bottom
+    ttk::button $mytoplevel.midi.buttonframe.apply -text [_ "Connect"]\
+        -command "::dialog_midi::apply $mytoplevel"
+    pack $mytoplevel.midi.buttonframe.apply -side left -expand 1 -fill x \
+        -padx 15
 }
